package repolist

import "go.wit.com/gui"

// This creates a view of the repos
// you can only have one at this point
func (rl *RepoList) AutotypistView(parent *gui.Node) {
	rl.allrepos = make(map[string]*RepoRow)
	rl.viewName = "autotypist"

	// rl.reposbox = gui.RawBox()
	rl.reposbox = parent

	rl.reposgroup = rl.reposbox.NewGroup("my git repositories (configure in ~/.config/autotypist)")
	// rl.reposgroup.Menu = repolistMenu() // how to do a menu? what should the code look like?
	rl.reposgrid = rl.reposgroup.NewGrid("test", 0, 0)

	rl.reposgrid.NewLabel("") // path goes here
	rl.reposgrid.NewLabel("last tag").SetProgName("last tag")
	rl.reposgrid.NewLabel("master version")
	rl.reposgrid.NewLabel("devel version")
	rl.reposgrid.NewLabel("user version")
	rl.reposgrid.NewLabel("Status")
	rl.reposgrid.NewLabel("Current").SetProgName("CurrentName")
	rl.reposgrid.NewLabel("Version").SetProgName("CurrentVersion")
	rl.reposgrid.NextRow()

	rl.blind = gui.RawBox()
	rl.shownCount = rl.blind.NewLabel("showCount")
	rl.duration = rl.blind.NewLabel("duration")
}
